
//	Copyright 2010 PaletteSoft LLC

//	******  ******  *******  *****   *****                                    
//	*     * *     * *       *     * *     *                                   
//	*     * *     * *       *       *                                         
//	******  ******  *******  *****   *****                                    
//	*       *   *   *             *       *                                   
//	*       *    *  *       *     * *     *                                   
//	*       *     * *******  *****   *****                                    

// ===========================================================================
// =	CL^																 =
// ===========================================================================
//	005 2010.10.31
//	EvO̐ by A.Ohta
// ---------------------------------------------------------------------------
//	004 2010.10.04
//	EPIC24FJ64GA002 p SHT-11 xZT[Rg[̒ǉ by A.Ohta
// ---------------------------------------------------------------------------
//	003 2010.10.02
//	EPIC24FJ64GA002 ɑΉוύXASHT-11 C^[tF[X폜Ł@by A.Ohta
// ---------------------------------------------------------------------------
//	002 2010.07.10
//	ESHT-11 C^[tF[XI[vhCɑΉ@by A.Ohta
// ---------------------------------------------------------------------------
//	001 2010.01.29
//	EVK쐬
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************
// ***************************************************************************

	//	*****  *****

#include	"p24FJ64GA002.h"											//  PIC^

#include	<uart.h>

	//	***** 錾 *****

#include	"_AtrDef24f.h"												//	萔Af[^^̐錾

	//	*****  *****

#include	"version.h"													//	o[Wԍ̒`

#include	"device.h"													//	foCX
#include	"press.h"													//	̓ZT
#include	"nokiaGlcdlib.h"											//  LCD

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

	//	***** rohʐM *****											//	CCCCCCA0	c@R}h͂Urbglra킹A`̓[hAkra͏ɂO

#define	PRS_SPI_WRITE			(1 << 1)								//	f[^݃[h
#define	PRS_SPI_READ			(0 << 1)								//	f[^ǂݏo[h

#define	PRS_SPI_ADJUST			2										//	_CNgR}hp̃rbgʒu̕␳

	//	***** R}h *****
																		//	Description							Mode	Access		Width
#define	PRS_COM_REVID			0x00									//	ASIC revision number				R		Direct		 8
#define	PRS_COM_DATAWR			0x01									//	Indirect register access data		RW		Direct		 8
#define	PRS_COM_ADDPTR			0x02									//	Indirect register access pointer	RW		Direct		 8
#define	PRS_COM_OPERATION		0x03									//	Operation register					RW		Direct		 8
#define	PRS_COM_OPSTATUS		0x04									//	Operation status					R		Direct		 8
#define	PRS_COM_RSTR			0x06									//	ASIC software reset					W		Direct		 8
#define	PRS_COM_STATUS			0x07									//	ASIC top-level status				R		Direct		 8
#define	PRS_COM_DATARD8			0x1f									//	Pressure output data (MSB) or ...	R		Direct		 8
#define	PRS_COM_DATARD16		0x20									//	Pressure output data (LSB) or ...	R		Direct		16
#define	PRS_COM_TEMPOUT			0x21									//	14-bit temperature output data		R		Direct		16

	//	***** 胂[h *****

#define	PRS_MEAS_STOP			0x00									//	Cancel current operation
#define	PRS_MEAS_HSPD			0x09									//	High speed acquisition mode
#define	PRS_MEAS_HRES			0x0a									//	High resolution acquisition mode
#define	PRS_MEAS_ULPW			0x0b									//	Ultra low power acquisition mode

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************
// ***************************************************************************

	//	***** R}h *****

void	PrsComPut8bit(UB Command, UB Data);
UB		PrsComGet8bit(UB Command);
UH		PrsComGet16bit(UB Command);

	//	***** Cu *****

UB*		LibHexAscUB(UB *Buffer, UB Value);								//	fobOp

// ***************************************************************************
// ***************************************************************************
// *	{																 *
// ***************************************************************************
// ***************************************************************************

//	
//	
//
// 		V[PX
//
//	
//	
void	PrsSeq______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	ʁiʂSrbgʁj
//----------------------------------------------------------------------------
//	lF	ZT[̋Nҋ@ANʂԂ܂B
//			N㈳̓ZT̓X^oC[hɂȂ܂B
//
//			mF̂߂ɂQނ̏ǂݏo܂Boɂkra𔻒f܂B
//			Oł邱ƁAPł邱ƂmF邱ƂAʓI
//			M̃`FbNifjmFɂȂ܂B
//
//			^pJnɃ}CRċNAZT^pp̏ꍇɃZT
//			o͂Cf[^ilraj`FbNTffʂƂēǂݍ
//			ł܂\܂B
//			ǂݏoWX^ɂւ炸AWX^e̐؂ւ^C~
//			OdlƂĖĂȂc炭ZTNɌ
//			WX^̓e`FbNTffʂɂȂĂƎv܂B
//			vcs𗘗p鎖lƁAݒ̖`ŃZTI
//			ɃZbg􂩂ƁB
//============================================================================
UB		PrsSeqInit(void)
{
	UB		Loop;														//	[vJE^
	UB		ReadData;													//	ǂݏof[^
	UB		DebugMessage[3];											//	fobO\p

	//	***** ZT̖IȃZbg *****									//	}CRȃZbgꍇɑΉ

	delay_ms(60);														//	tF[YPFUOҋ@
	delay_ms(90);														//	tF[YQFXOҋ@	c@d͋NĂ͂̃^C~O҂
	
	PrsComPut8bit(PRS_COM_RSTR, 0x01);									//	`rhb\tgEFÃZbg
	delay_ms(10);														//	POҋ@

	//	***** tF[YPFX^[gAbv *****

	;																	//	ocM͕Iɕs\Ȃ̂Œʏ̃X^[gAbv

	delay_ms(60);														//	UOҋ@

	//	***** tF[YQFݒXe[^XmF *****

	Loop = 0;															//	[vJE^NA

	while (1) {															//	mFł܂ŏ
		ReadData = PrsComGet8bit(PRS_COM_STATUS);						//	Xe[^XWX^擾
#if 1
		putsUART1((unsigned int *)LibHexAscUB(DebugMessage, ReadData));					//	ʂPUiɕϊĕ\
		putsUART1((unsigned int *)" ");
#endif
		if (ReadData & (UB)BIT00) {										//	Xe[^XWX^mFBfoCX͏ݒ蒆H
			if (Loop >= 6) {											//	U܂H
				return(PRS_INIT_RESULT_FAIL | Loop);					//	X^[gAbvsA	[v񐔂𔺂Eo
			}
			delay_ms(10);												//	POҋ@
			Loop ++;													//	[v񐔍XV
		}
		else {															//	ݒ芮
			break;														//	Eo
		}
	}

	//	***** tF[YQF`FbNTG[mF *****

	ReadData = PrsComGet8bit(PRS_COM_DATARD8);							//	Wrbgf[^擾B
#if 1
	putsUART1((unsigned int *)LibHexAscUB(DebugMessage, ReadData));						//	ʂPUiɕϊĕ\
	putsUART1((unsigned int *)" ");
#endif
	if ((ReadData & (UB)BIT00) == 0) {									//	ddoqnl`FbNTُH
		return(PRS_INIT_RESULT_CSUM | Loop);							//	`FbNTُ팟oA	[v񐔂𔺂Eo
	}

	//	***** ܂ *****

	return(PRS_INIT_RESULT_OK | Loop);									//	ݒ萳IA		[v񐔂𔺂ʏEo
}

//============================================================================
//	rWԍ擾
//----------------------------------------------------------------------------
//	́F	
//	óF	rWԍ
//----------------------------------------------------------------------------
//	lF	ZT̂`rhb\tgEFÃrW擾܂B
//============================================================================
UB		PrsSeqGetRevid(void)
{
	return(PrsComGet8bit(PRS_COM_REVID));								//	rWhc擾ĕԂ܂
}

//============================================================================
//	Jn
//----------------------------------------------------------------------------
//	́F	
//	óF	ʁisqtd^e`krdj
//----------------------------------------------------------------------------
//	lF	݂̑胂[hAVKɑJn܂B
//============================================================================
BOOL	PrsSeqMeas(void)
{
	UB		Loop;														//	[vJE^

	//	***** ~ *****

	PrsComPut8bit(PRS_COM_OPERATION, PRS_MEAS_STOP);					//	~

	//	***** ~̊mF *****											//	TȎҋ@őpĂiɑ~ԂłΖӖƂcj

	Loop = 0;															//	[vJE^̃NA

	while (1) {															//	mFł܂ŏ
		if (PrsComGet8bit(PRS_COM_OPSTATUS) & (UB)BIT00) {				//	Iy[VXe[^XWX^mFBfoCX̓Iy[VƒH
			if (Loop >= 10) {											//	PO܂H
				return(FALSE);											//	ُIŋEo
			}
			delay_ms(10);												//	POҋ@
			Loop ++;													//	[v񐔍XV
		}
		else {															//	Iy[Vƒ~
			break;														//	Eo
		}
	}

	//	***** A^CG[ *****

	PrsComGet8bit(PRS_COM_DATARD8);										//	Cf[^ǂݏoi@Wrbgj
	PrsComGet16bit(PRS_COM_DATARD16);									//	Cf[^ǂݏoiPUrbgj	ꂪ厖BǁAPȂ_~[[h

	//	***** Jn *****												//	ǂꂩPI

//*	PrsComPut8bit(PRS_COM_OPERATION, PRS_MEAS_HSPD);					//	x胂[hJn
	PrsComPut8bit(PRS_COM_OPERATION, PRS_MEAS_HRES);					//	x胂[hJn
//*	PrsComPut8bit(PRS_COM_OPERATION, PRS_MEAS_ULPW);					//	d̓[hJn

	//	***** ܂ *****

	return(TRUE);														//	܂łΐI
}

//============================================================================
//	f[^擾
//----------------------------------------------------------------------------
//	́F	f[^i[AhX
//	óF	ʁisqtd^e`krdj
//----------------------------------------------------------------------------
//	lF	芮ҋ@Af[^ꊇ擾܂B
//			A^CG[oꍇ͏ʂُIƂ܂B
//			ꍇ͑f[^̐M͂܂B
//============================================================================
BOOL	PrsSeqGetData(sPres *Measure)
{
	BOOL	Result = TRUE;												//	I


	//	***** 芮ҋ@ *****

	while (1) {															//	ʏ
		if (prsDRDY) {													//	f[^ZbgH
			break;														//	Eo
		}
		delay_ms(10);
		IPC4bits.CNIP = 5;												// @ԕω荞݃x5 ɐݒ
		IFS1bits.CNIF = 0;												//  CNINT clear
		CNEN2 = 0x0800;													//  CN27IE(RB5) enable
		IEC1bits.CNIE = 1;												//  CN int enable
		asm("PWRSAV	#0");												//  SLEEP mode
	}

	//	***** Xe[^X擾 *****

	Measure->Status1  = PrsComGet8bit(PRS_COM_STATUS);					//	Xe[^Xif[^擾Oj

	//	***** f[^擾 *****

	Measure->Temp	 = PrsComGet16bit(PRS_COM_TEMPOUT);					//	xf[^

	Measure->PresMsb = PrsComGet8bit(PRS_COM_DATARD8);					//	Cf[^ilraj
	Measure->PresLsb = PrsComGet16bit(PRS_COM_DATARD16);				//	Cf[^ikraj

	//	***** Xe[^X擾 *****

	Measure->Status2  = PrsComGet8bit(PRS_COM_STATUS);					//	Xe[^Xif[^擾j

	//	***** A^CG[mF *****

	if (Measure->Status2 & (UB)BIT04) {									//	A^CG[oH
		PrsComGet16bit(PRS_COM_DATARD16);								//	G[̂߃_~[[h
		Result = FALSE;													//	ُIł
	}

	//	***** ܂ *****

	return(Result);														//	ʂԂ܂

}

//	
//	
//
// 		ZTZ
//
//	
//	
void	PrsCal______(void) {}											//	op֐

//============================================================================
//	ꂽCf[^擾
//----------------------------------------------------------------------------
//	́F	f[^i[AhX
//	óF	PXrbgCf[^i0.25Pa/bitj
//----------------------------------------------------------------------------
//	lF	Cf[^𐶐܂B
//============================================================================
UW		PrsCalGetPres(sPres *Measure)
{
	UW		Value;														//	Cf[^

	*((UH*)&Value + BYTE_OFFSET_H) = (UH)(Measure->PresMsb & 0x07);		//	ACf[^̂lrãf[^ʃ[hɋl߂
	*((UH*)&Value + BYTE_OFFSET_L) = (UH)Measure->PresLsb;				//	BʁAʂ̃ItZbg͂Q{Ă͂

	return(Value);														//	Cf[^Ԃ܂
}

//============================================================================
//	ꂽxf[^擾
//----------------------------------------------------------------------------
//	́F	f[^i[AhX
//	óF	PUrbgxf[^i0.05c/bitj
//----------------------------------------------------------------------------
//	lF	xf[^̗\̈폜ĎZplɕ␳܂B
//============================================================================
UH		PrsCalGetTemp(sPres *Measure)
{
	UH		Value;														//	xf[^

	Value = Measure->Temp;												//	xf[^ǂݏo

	if (Value & (UH)BIT13) {											//	}CiXxH
		Value |= ( (UH)0xe000);											//	SȂQ̕␔\
	}
	else {																//	vXx
		Value &= (~(UH)0xe000);											//	\̈NA
	}

	return(Value);														//	xf[^Ԃ܂
}

//	
//	
//
// 		R}h
//
//	
//	
void	PrsCom______(void) {}											//	op֐

#define	mSpiLock()				DevSigPutCSB_L()						//	foCXI
#define	mSpiRelease()			DevSigPutCSB_H()						//	foCX

//============================================================================
//	Wrbgf[^
//----------------------------------------------------------------------------
//	́F	R}hf[^A݃f[^
//	óF	
//----------------------------------------------------------------------------
//	lF	R}h𑗐MAăf[^݂܂B
//============================================================================
void	PrsComPut8bit(UB Command, UB Data)
{
	mSpiLock();															//	foCXI

	DevSpiPutData((Command << PRS_SPI_ADJUST) | PRS_SPI_WRITE);			//	R}hZbg
	DevSpiPutData(Data);												//	f[^Zbg

	mSpiRelease();														//	foCX
}

//============================================================================
//	Wrbgf[^ǂݏo
//----------------------------------------------------------------------------
//	́F	R}h
//	óF	ǂݏo
//----------------------------------------------------------------------------
//	lF	R}h𑗐MAWrbgf[^ǂݏo܂B
//============================================================================
UB		PrsComGet8bit(UB Command)
{
	UB		Result;														//	ǂݏo

	mSpiLock();															//	foCXI

	DevSpiPutData((Command << PRS_SPI_ADJUST) | PRS_SPI_READ);			//	R}hZbg
	Result = DevSpiGetData();											//	Wrbg̎M

	mSpiRelease();														//	foCX

	return(Result);
}

//============================================================================
//	PUrbgf[^ǂݏo
//----------------------------------------------------------------------------
//	́F	R}hAf[^i[AhX
//	óF	ǂݏof[^
//----------------------------------------------------------------------------
//	lF	R}h𑗐MAPUrbgf[^ǂݏo܂B
//============================================================================
UH		PrsComGet16bit(UB Command)
{
	UH		Result;														//	ǂݏo

	mSpiLock();															//	foCXI

	DevSpiPutData((Command << PRS_SPI_ADJUST) | PRS_SPI_READ);			//	R}hZbg
	mPutByteH(&Result, DevSpiGetData());								//	ʂWrbg̎M
	mPutByteL(&Result, DevSpiGetData());								//	ʂWrbg̎M

	mSpiRelease();														//	foCX

	return(Result);
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC
